#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Odds2_Buff.h"
#include "FileEncrypt.h"
std::auto_ptr<Odds2_Buff> Odds2_Buff::msSingleton(nullptr);

int Odds2_Buff::GetCount()
{
	return (int)mMapData.size();
}

const Odds2_BuffData* Odds2_Buff::GetData(int BuffID)
{
	auto it = mMapData.find(BuffID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Odds2_BuffData>& Odds2_Buff::GetMapData()
{
	return mMapData;
}

void Odds2_Buff::Reload()
{
	mMapData.clear();
	Load();
}

void Odds2_Buff::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Odds2_BuffData data;
		data.mBuffID = element->IntAttribute("BuffID");
		data.mThreshold = element->IntAttribute("Threshold");
		data.mBuffEffect = element->IntAttribute("BuffEffect");
		data.mBuffEffectMin = element->IntAttribute("BuffEffectMin");
		data.mBuffEffectMax = element->IntAttribute("BuffEffectMax");
		data.mBuffInviMin = element->IntAttribute("BuffInviMin");
		data.mBuffInviMax = element->IntAttribute("BuffInviMax");
		data.mSpecialFishMin = element->IntAttribute("SpecialFishMin");
		data.mSpecialFishMax = element->IntAttribute("SpecialFishMax");
		data.mBuffCount = element->IntAttribute("BuffCount");
		if (mMapData.find(data.mBuffID) != mMapData.end())std::cout <<"data refind:" << data.mBuffID << std::endl;
		assert(mMapData.find(data.mBuffID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mBuffID, data));
		element = element->NextSiblingElement();
	}
}

void Odds2_Buff::Load()
{
	Load("../Config/Odds2_Buff.xml");
}

Odds2_Buff* Odds2_Buff::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Odds2_Buff());
	}
	return msSingleton.get();
}
